package api

import (
	"fmt"
	"net/http"
	"sku3dweb/bus"
	"time"

	"github.com/gin-gonic/gin"
	"go.mongodb.org/mongo-driver/bson/primitive"
	"infish.cn/comm"
)

func RegQueenterApis(router *GinRouter) {
	router.POST("/queenter/upload/:username", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
		body := &comm.AssetMatGroup{}
		err := c.ShouldBindJSON(body)
		if err != nil {
			return nil, err
		}
		username := c.Param("username")
		if len(username) < 1 {
			return nil, fmt.Errorf("username不能为空")
		}
		user, err := bus.GetUserInfoByName(username)
		if err != nil {
			return nil, err
		}

		body.Id = primitive.NilObjectID
		body.UserId = user.Id
		body.UserInfo = &comm.AssetUserInfo{Name: user.Name, Thumbnail: &comm.OssType{Url: user.Avatar}}
		body.Enable = BoolValue(false)
		body.AssetState = comm.AssetState_Succ
		body.CreateTime = time.Now()
		body.UpdateTime = time.Now()

		isCompany := true
		srcColl := getAssetTypeCollectin(isCompany, false, "user", "fabric3d")

		return bus.BusTreeAssetMatgroupAdd(Sku3dDbName, srcColl, body)
	})

	//获取设备上传时候的分类
	router.GET("/queenter/categories", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {

		username := "dadong"
		if len(username) < 1 {
			return nil, fmt.Errorf("username不能为空")
		}
		user, err := bus.GetUserInfoByName(username)
		if err != nil {
			return nil, err
		}

		//获取面料的分类
		cates := &comm.DbCategory{}
		defineName := "company_mats_user"
		err = bus.TreeQueryDbCategory(&bus.TreeQueryDbCategoryReq{
			DefineCollection: defineName,
			DbName:           "sku3d-tree",
			UserId:           user.Id.Hex(),
			AssetScope:       "sku3d",
		}, cates)

		if err != nil {
			return nil, err
		}
		c.JSON(http.StatusOK, cates)

		return nil, nil
	})
}
