package model

import (
	"time"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

type MatImage struct {
	Id        primitive.ObjectID `bson:"_id,omitempty" json:"_id"`
	UserId    primitive.ObjectID `bson:"userId,omitempty" json:"userId,omitempty"` //用户Id
	Thumbnail *OssType           `bson:"thumbnail,omitempty" json:"thumbnail"`     //封面图
	RawImage  *OssType           `bson:"rawImage,omitempty" json:"rawImage"`       //原始大图
	PhyWidth  int                `bson:"phyWidth,omitempty" json:"phyWidth"`       //物理尺寸 宽度
	PhyHeight int                `bson:"phyHeight,omitempty" json:"phyHeight"`     //物理尺寸 高度

	CreateTime time.Time `bson:"createTime,omitempty" json:"createTime"`
	UpdateTime time.Time `bson:"updateTime,omitempty" json:"updateTime"`

	NameCN string `bson:"nameCn,omitempty" json:"nameCn"` //中文名称
	NameEN string `bson:"nameEn,omitempty" json:"nameEn"` //英文名称
	From   string `bson:"from,omitempty" json:"from"`     //来源
	Price  int    `bson:"price,omitempty" json:"price"`   //价格 //单位分

	Categories []string `bson:"categories,omitempty" json:"categories"`   //所属分类Id
	CusNum     string   `bson:"cusNum,omitempty" json:"cusNum,omitempty"` //编号
}
