package model

type UvSize struct {
	Width  int `bson:"width,omitempty" json:"width,omitempty"`
	Height int `bson:"height,omitempty" json:"height,omitempty"`
}

type MatAlbedo struct {
	Color      *Vect3   `bson:"color" json:"color"`
	Texture    *OssType `bson:"texture" json:"texture"`
	UseTexture *bool    `bson:"useTexture" json:"useTexture"`
}

type MatRoughness struct {
	UseTexture *bool    `bson:"useTexture" json:"useTexture"`
	Texture    *OssType `bson:"texture" json:"texture"`
	Factor     *float32 `bson:"factor" json:"factor"`
}

type MatMetalness struct {
	UseTexture *bool    `bson:"useTexture" json:"useTexture"`
	Texture    *OssType `bson:"texture" json:"texture"`
	Factor     *float32 `bson:"factor" json:"factor"`
}
type MatNormal struct {
	UseTexture *bool    `bson:"useTexture" json:"useTexture"`
	Texture    *OssType `bson:"texture" json:"texture"`
	Factor     *float32 `bson:"factor" json:"factor"`
	FlipY      *bool    `bson:"flipY" json:"flipY"`
}

type MatOpacity struct {
	Enable     bool     `bson:"enable" json:"enable"`
	Factor     *float32 `bson:"factor" json:"factor"`
	Texture    *OssType `bson:"texture" json:"texture"`
	UseTexture *bool    `bson:"useTexture" json:"useTexture"`
}

type TechMatConfig struct {
	Version     int           `bson:"version,omitempty" json:"version"`
	Type        string        `bson:"type,omitempty" json:"type"`
	Uvtransform *MaterailUv   `bson:"uvtransform,omitempty" json:"uvtransform"`
	CullFace    string        `bson:"cullFace" json:"cullFace"`
	Albedo      *MatAlbedo    `bson:"albedo" json:"albedo"`
	Roughness   *MatRoughness `bson:"roughness" json:"roughness"`
	Metalness   *MatMetalness `bson:"metalness" json:"metalness"`
	Specular    *MatAlbedo    `bson:"specular" json:"specular"`
	Normal      *MatNormal    `bson:"normal" json:"normal"`
	Opacity     *MatOpacity   `bson:"opacity" json:"opacity"`
}

type MeshMatConf struct {
	UvMap        *OssType          `bson:"uvmap" json:"uvmap"`
	UvSize       *UvSize           `bson:"uvsize" json:"uvsize"`
	Name         string            `bson:"name" json:"name"`
	Material     *MatConfig        `bson:"material" json:"material"`
	TechMaterial *TechMatConfig    `bson:"techMaterial" json:"techMaterial"`
	Images       []*ComponentImage `bson:"images" json:"images"`

	Index   int   `bson:"index" json:"index"`
	Visible *bool `bson:"visible" json:"visible"`
}
type Obb struct {
	Min Vec3Obj `bson:"min,omitempty" json:"min"`
	Max Vec3Obj `bson:"max,omitempty" json:"max"`
}

type StaticMeshSource struct {
	Components  []*MeshMatConf `bson:"components,omitempty" json:"components"`
	Osgjs       *OssType       `bson:"osgjs,omitempty" json:"osgjs"`
	File        *OssType       `bson:"file,omitempty" json:"file"` //hdr or fbx
	Glb         *OssType       `bson:"glb,omitempty" json:"glb"`   //hdr or fbx
	Shadow      *OssType       `bson:"shadow,omitempty" json:"shadow,omitempty"`
	BoundingBox *Obb           `bson:"boundingBox,omitempty" json:"boundingBox,omitempty"`
}
